"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.displayWarning = exports.displayException = exports.displayError = exports.displayCodegenInitialized = exports.displaySuccess = void 0;
/* eslint-disable no-console */
var chalk_1 = __importDefault(require("chalk"));
var displaySuccess = function (outPath, _a) {
    var typesCount = _a.typesCount;
    var summary = "".concat(chalk_1.default.greenBright(typesCount), " types generated");
    console.info("".concat(chalk_1.default.cyanBright('graphql-codegen-react-query'), " \uD83D\uDE80 - ").concat(chalk_1.default.greenBright('Types generated and saved in'), " ").concat(chalk_1.default.underline.cyanBright(outPath), " (").concat(summary, ")"));
};
exports.displaySuccess = displaySuccess;
var displayCodegenInitialized = function () {
    console.log("".concat(chalk_1.default.cyanBright('graphql-codegen-react-query'), " \u2705 - ").concat(chalk_1.default.greenBright('Codegen initialized!')));
};
exports.displayCodegenInitialized = displayCodegenInitialized;
var displayError = function (message) {
    console.error("".concat(chalk_1.default.cyanBright('graphql-codegen-react-query'), " \u274C - ").concat(chalk_1.default.redBright(message)));
};
exports.displayError = displayError;
var displayException = function (err) {
    console.error("".concat(chalk_1.default.cyanBright('graphql-codegen-react-query'), " \u274C - ").concat(chalk_1.default.redBright(err.stack)));
};
exports.displayException = displayException;
var displayWarning = function (text, id) {
    var optionalId = id ? " ".concat(chalk_1.default.magentaBright(id), ":") : '';
    console.info("".concat(chalk_1.default.cyanBright('graphql-codegen-react-query'), " \uD83D\uDEA8 -").concat(optionalId, " ").concat(chalk_1.default.hex('#FFA500')(text)));
};
exports.displayWarning = displayWarning;
