"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateArguments = void 0;
var chalk_1 = __importDefault(require("chalk"));
var fs_extra_1 = require("fs-extra");
var yaml_1 = __importDefault(require("yaml"));
var helpers_1 = require("yargs/helpers");
var yargs_1 = __importDefault(require("yargs/yargs"));
var options_validation_1 = require("./options-validation");
var validateArguments = function () { return __awaiter(void 0, void 0, void 0, function () {
    var defaultConfigFilePath, argv, configFileExists, configData, config, fetcher, outputPath, schemaUrl, infiniteQueries;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                defaultConfigFilePath = './react-query.codegen.yml';
                argv = (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
                    .scriptName('gqlCodegen')
                    .usage(chalk_1.default.blueBright('$0 -c [configFilePath]'))
                    .epilogue('Generates types and react-query hooks from a graphql schema')
                    .example('$0 -c ./libs/graphql/react-query.codegen.yml', '')
                    .describe('c', chalk_1.default.cyanBright('Codegen config file path'))
                    .default('c', defaultConfigFilePath)
                    .demandOption(['c']).argv;
                return [4 /*yield*/, (0, fs_extra_1.pathExists)(argv.c)];
            case 1:
                configFileExists = _a.sent();
                if (!configFileExists) {
                    throw new Error(chalk_1.default.bold.redBright("Errors:\n-c\t\tConfig file ".concat(argv.c, " doesn't exist\n")));
                }
                return [4 /*yield*/, (0, fs_extra_1.readFile)(argv.c, 'UTF8')];
            case 2:
                configData = _a.sent();
                config = yaml_1.default.parse(configData);
                return [4 /*yield*/, (0, options_validation_1.validateFetcherOption)(config)];
            case 3:
                fetcher = _a.sent();
                outputPath = (0, options_validation_1.validateOutputPath)(config);
                schemaUrl = (0, options_validation_1.validateSchemaUrl)(config);
                infiniteQueries = (0, options_validation_1.validateInfiniteQueries)(config);
                return [2 /*return*/, {
                        fetcher: fetcher,
                        outputPath: outputPath,
                        schemaUrl: schemaUrl,
                        infiniteQueries: infiniteQueries,
                    }];
        }
    });
}); };
exports.validateArguments = validateArguments;
