"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateArguments = void 0;
var chalk_1 = __importDefault(require("chalk"));
var helpers_1 = require("yargs/helpers");
var yargs_1 = __importDefault(require("yargs/yargs"));
var validateArguments = function () {
    var defaultConfigFilePath = '.';
    var defaultCodegenOutputPath = './api';
    var defaultApiUrl = 'http://localhost:3333/graphql';
    var argv = (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
        .scriptName('gqlCodegenInit')
        .usage(chalk_1.default.blueBright('$0 -c [configFilePath] -o [generatedCodePath]'))
        .epilogue('Initializing codegen tooling by creating a config file and the fetcher hook')
        .example('$0 -c ./libs/graphql/codegen -o ./libs/graphql/artifacts', '')
        .describe('c', chalk_1.default.cyanBright('Where to write the codegen config file'))
        .default('c', defaultConfigFilePath)
        .describe('o', chalk_1.default.cyanBright('Where generated code should be written'))
        .default('o', defaultCodegenOutputPath)
        .describe('u', chalk_1.default.cyanBright('Graphql api url'))
        .default('u', defaultApiUrl)
        .demandOption(['c', 'o', 'u']).argv;
    return {
        codegenConfigFilePath: argv.c,
        codegenOutputPath: argv.o,
        apiUrl: argv.u,
    };
};
exports.validateArguments = validateArguments;
