"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generareInfiniteQueries = void 0;
var fs_extra_1 = require("fs-extra");
var infinite_query_hook_content_1 = require("./content/infinite-query-hook-content");
var capitalize_1 = require("../../util/capitalize");
var generareInfiniteQueries = function (fields, infiniteQueries, fetcher, outputPath, selectors) { return __awaiter(void 0, void 0, void 0, function () {
    var generatedInfiniteQueries, _loop_1, infiniteQueries_1, infiniteQueries_1_1, infiniteQueryName, e_1_1;
    var e_1, _a;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                if (infiniteQueries.length === 0 || fields === null) {
                    return [2 /*return*/, []];
                }
                generatedInfiniteQueries = [];
                _loop_1 = function (infiniteQueryName) {
                    var query, regex, selector, selectorType, selectorValue, type, variables, variablesArgument, data;
                    return __generator(this, function (_d) {
                        switch (_d.label) {
                            case 0:
                                query = fields.find(function (el) { return el.name === infiniteQueryName; });
                                if (!query) {
                                    return [2 /*return*/, "continue"];
                                }
                                regex = new RegExp("^".concat(query.name, "\\?: {(.*)}$"), 'm');
                                selector = (_b = regex.exec(selectors.querySelector)) === null || _b === void 0 ? void 0 : _b[1];
                                selectorType = selector === null || selector === void 0 ? void 0 : selector.replace(/\?: /g, ': ');
                                selectorValue = selector === null || selector === void 0 ? void 0 : selector.replace(/\?: boolean;/g, ': true,').replace(/\?: {/g, ': {').replace(/};/g, '},');
                                type = (0, capitalize_1.capitalize)(query.name);
                                variables = '';
                                variablesArgument = '';
                                if (query.args && query.args.length > 0) {
                                    variables = ", variables";
                                    variablesArgument = "variables: ".concat(type, "QueryArgs,");
                                }
                                data = infinite_query_hook_content_1.infiniteQueryHookContent
                                    .replace('#fetcher-hook-import#', "import { ".concat(fetcher.functionName, " } from '").concat(fetcher.path, "';"))
                                    .replace(/#type#/g, type)
                                    .replace(/#name#/g, query.name)
                                    .replace('#full-selector-type#', selectorType || '')
                                    .replace('#full-selector#', selectorValue || '')
                                    .replace('#variables-argument#', variablesArgument)
                                    .replace('#variables#', variables);
                                return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/queries/use").concat(type, "InfiniteQuery.ts"), data)];
                            case 1:
                                _d.sent();
                                generatedInfiniteQueries.push("use".concat(type, "InfiniteQuery"));
                                return [2 /*return*/];
                        }
                    });
                };
                _c.label = 1;
            case 1:
                _c.trys.push([1, 6, 7, 8]);
                infiniteQueries_1 = __values(infiniteQueries), infiniteQueries_1_1 = infiniteQueries_1.next();
                _c.label = 2;
            case 2:
                if (!!infiniteQueries_1_1.done) return [3 /*break*/, 5];
                infiniteQueryName = infiniteQueries_1_1.value;
                return [5 /*yield**/, _loop_1(infiniteQueryName)];
            case 3:
                _c.sent();
                _c.label = 4;
            case 4:
                infiniteQueries_1_1 = infiniteQueries_1.next();
                return [3 /*break*/, 2];
            case 5: return [3 /*break*/, 8];
            case 6:
                e_1_1 = _c.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 8];
            case 7:
                try {
                    if (infiniteQueries_1_1 && !infiniteQueries_1_1.done && (_a = infiniteQueries_1.return)) _a.call(infiniteQueries_1);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 8: return [2 /*return*/, generatedInfiniteQueries];
        }
    });
}); };
exports.generareInfiniteQueries = generareInfiniteQueries;
