"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateDocument = void 0;
var capitalize_1 = require("../../../util/capitalize");
var getGqlType = function (type, required) {
    var _a, _b;
    if (type.kind === 'LIST') {
        return "[".concat((_b = (_a = type.ofType) === null || _a === void 0 ? void 0 : _a.ofType) === null || _b === void 0 ? void 0 : _b.name, "!]").concat(required);
    }
    return "".concat(type.name).concat(required);
};
var generateDocument = function (name, args, resultType, resultKind) {
    var result = resultKind === 'object' ? "{ ".concat(resultType, " }") : '';
    return "mutation ".concat((0, capitalize_1.capitalize)(name), "(").concat(args &&
        args
            .map(function (el) {
            var type = '';
            if (el.type.kind === 'NON_NULL') {
                type = getGqlType(el.type.ofType, '!');
            }
            else {
                type = getGqlType(el.type, '');
            }
            return "$".concat(el.name, ": ").concat(type);
        })
            .join(', '), ") {\n    ").concat(name, "(").concat(args && args.map(function (el) { return "".concat(el.name, ": $").concat(el.name); }).join(', '), ") ").concat(result, "\n  }");
};
exports.generateDocument = generateDocument;
