"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateMutations = void 0;
var fs_extra_1 = require("fs-extra");
var mutation_hook_content_1 = require("./content/mutation-hook-content");
var generate_document_1 = require("./document/generate-document");
var get_mutation_result_types_1 = require("./result-type/get-mutation-result-types");
var get_types_imports_1 = require("./types-imports/get-types-imports");
var capitalize_1 = require("../../util/capitalize");
var generateMutations = function (fields, types, fetcher, outputPath) { return __awaiter(void 0, void 0, void 0, function () {
    var fields_1, fields_1_1, _a, type, name_1, args, mutationType, hasArgs, mutationArgsType, argType, _b, documentResultFields, resultType, resultKind, document_1, typesImports, data, e_1_1;
    var e_1, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                if (fields === null) {
                    return [2 /*return*/];
                }
                _d.label = 1;
            case 1:
                _d.trys.push([1, 6, 7, 8]);
                fields_1 = __values(fields), fields_1_1 = fields_1.next();
                _d.label = 2;
            case 2:
                if (!!fields_1_1.done) return [3 /*break*/, 5];
                _a = fields_1_1.value, type = _a.type, name_1 = _a.name, args = _a.args;
                mutationType = (0, capitalize_1.capitalize)(name_1);
                hasArgs = (args === null || args === void 0 ? void 0 : args.length) && args.length > 0;
                mutationArgsType = hasArgs
                    ? "".concat(mutationType, "MutationArgs")
                    : 'unknown';
                argType = hasArgs
                    ? "export type ".concat(mutationType, "MutationArgs = Args\n")
                    : "";
                _b = (0, get_mutation_result_types_1.getMutationResultTypes)(name_1, type, types), documentResultFields = _b.documentResultFields, resultType = _b.resultType, resultKind = _b.resultKind;
                document_1 = (0, generate_document_1.generateDocument)(name_1, args, documentResultFields, resultKind);
                typesImports = (0, get_types_imports_1.getTypesImports)(name_1, mutationArgsType, types, resultType);
                data = mutation_hook_content_1.mutationHookContent
                    .replace('#fetcher-hook-import#', "import { ".concat(fetcher.functionName, " } from '").concat(fetcher.path, "';"))
                    .replace('#mutation-types-import#', typesImports)
                    .replace('#name#', name_1)
                    .replace('#args-type#', argType)
                    .replace(/#mutation-result-type#/g, resultType)
                    .replace(/#mutation-args-type#/g, mutationArgsType)
                    .replace(/#type#/g, mutationType)
                    .replace('#document#', document_1);
                return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/mutations/use").concat(mutationType, "Mutation.ts"), data)];
            case 3:
                _d.sent();
                _d.label = 4;
            case 4:
                fields_1_1 = fields_1.next();
                return [3 /*break*/, 2];
            case 5: return [3 /*break*/, 8];
            case 6:
                e_1_1 = _d.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 8];
            case 7:
                try {
                    if (fields_1_1 && !fields_1_1.done && (_c = fields_1.return)) _c.call(fields_1);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 8: return [2 /*return*/];
        }
    });
}); };
exports.generateMutations = generateMutations;
