"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMutationResultTypes = void 0;
var get_result_fields_1 = require("./get-result-fields");
var console_messages_1 = require("../../../../cli/console/console.messages");
var translate_graphql_type_to_typescript_1 = require("../../../parsing/typescript/translate-graphql-type-to-typescript");
var getMutationResultTypes = function (name, type, types) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    if (type.kind === 'NON_NULL') {
        if (((_a = type.ofType) === null || _a === void 0 ? void 0 : _a.kind) === 'LIST') {
            var typeName_1 = (_d = (_c = (_b = type.ofType) === null || _b === void 0 ? void 0 : _b.ofType) === null || _c === void 0 ? void 0 : _c.ofType) === null || _d === void 0 ? void 0 : _d.name;
            if (!typeName_1) {
                (0, console_messages_1.displayWarning)("Missing");
                return {
                    documentResultFields: '',
                    resultType: 'Array<never>',
                    resultKind: 'object',
                };
            }
            return {
                documentResultFields: (0, get_result_fields_1.getResultFields)(name, typeName_1, types),
                resultType: "Array<".concat(typeName_1, ">"),
                resultKind: 'object',
            };
        }
        else if (((_e = type.ofType) === null || _e === void 0 ? void 0 : _e.kind) === 'SCALAR') {
            var typeName_2 = (_f = type.ofType) === null || _f === void 0 ? void 0 : _f.name;
            return {
                documentResultFields: typeName_2,
                resultType: (0, translate_graphql_type_to_typescript_1.translateGraphqlTypeToTypescript)(typeName_2),
                resultKind: 'scalar',
            };
        }
        var typeName_3 = (_g = type.ofType) === null || _g === void 0 ? void 0 : _g.name;
        return {
            documentResultFields: (0, get_result_fields_1.getResultFields)(name, typeName_3, types),
            resultType: typeName_3,
            resultKind: 'object',
        };
    }
    if (type.kind === 'LIST') {
        var typeName_4 = (_j = (_h = type.ofType) === null || _h === void 0 ? void 0 : _h.ofType) === null || _j === void 0 ? void 0 : _j.name;
        return {
            documentResultFields: (0, get_result_fields_1.getResultFields)(name, typeName_4, types),
            resultType: "Array<".concat(typeName_4, "> | undefined"),
            resultKind: 'object',
        };
    }
    else if (type.kind === 'SCALAR') {
        var typeName_5 = type.name;
        return {
            documentResultFields: typeName_5,
            resultType: "".concat((0, translate_graphql_type_to_typescript_1.translateGraphqlTypeToTypescript)(typeName_5), " | undefined"),
            resultKind: 'scalar',
        };
    }
    var typeName = type.name;
    return {
        documentResultFields: (0, get_result_fields_1.getResultFields)(name, typeName, types),
        resultType: "".concat(typeName, " | undefined"),
        resultKind: 'object',
    };
};
exports.getMutationResultTypes = getMutationResultTypes;
