"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getResultFields = void 0;
var console_messages_1 = require("../../../../cli/console/console.messages");
var getResultFields = function (name, type, types) {
    var _a;
    var maybeType = types.find(function (t) { return t.name === type; });
    if (!maybeType) {
        return type;
    }
    var fields = (_a = new RegExp("^export interface ".concat(type, " { (.*) }$"), 'm').exec(maybeType.data)) === null || _a === void 0 ? void 0 : _a[1];
    if (!fields) {
        (0, console_messages_1.displayWarning)("Type ".concat(type, " missing in generated types"));
        return '';
    }
    return fields
        .split(';')
        .slice(0, -1)
        .map(function (field) {
        var _a = __read(field.split(':').map(function (el) { return el.trim(); }), 2), varName = _a[0], type = _a[1];
        var withoutQuestionMark = varName.endsWith('?')
            ? varName.slice(0, -1)
            : varName;
        if (types.some(function (t) { return t.name === type && t.type === 'type'; })) {
            return "".concat(withoutQuestionMark, " { ").concat((0, exports.getResultFields)(name, type, types), " }");
        }
        return withoutQuestionMark;
    })
        .join('\n');
};
exports.getResultFields = getResultFields;
