"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateSelectors = void 0;
var fs_extra_1 = require("fs-extra");
var generate_query_selector_1 = require("../../parsing/query-selector/generate-query-selector");
var generate_query_selector_result_1 = require("../../parsing/query-selector/generate-query-selector-result");
var decapitalize_1 = require("../../util/decapitalize");
var generateSelectors = function (queryObject, types, outputPath) { return __awaiter(void 0, void 0, void 0, function () {
    var querySelector, result, result_1, result_1_1, _a, name_1, content, imports, importString, type, e_1_1, querySelectorResult;
    var e_1, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                querySelector = (0, generate_query_selector_1.generateQuerySelector)(queryObject, types);
                return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/types/query-selector.ts"), querySelector)];
            case 1:
                _c.sent();
                result = (0, generate_query_selector_result_1.generateQuerySelectorResult)(queryObject, types);
                _c.label = 2;
            case 2:
                _c.trys.push([2, 8, 9, 10]);
                result_1 = __values(result), result_1_1 = result_1.next();
                _c.label = 3;
            case 3:
                if (!!result_1_1.done) return [3 /*break*/, 7];
                _a = result_1_1.value, name_1 = _a.name, content = _a.content, imports = _a.imports;
                importString = '';
                if (imports !== undefined && imports.length > 0) {
                    importString = "import { ".concat(imports.join(', '), " } from '../../api-types';\n\n");
                }
                type = (0, decapitalize_1.decapitalize)(name_1);
                return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/types/queries/").concat(type))];
            case 4:
                _c.sent();
                return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/types/queries/").concat(type, "/").concat(name_1, "QueryResult.type.ts"), "".concat(importString, "export type ").concat(name_1, "QueryResult = ").concat(content))];
            case 5:
                _c.sent();
                _c.label = 6;
            case 6:
                result_1_1 = result_1.next();
                return [3 /*break*/, 3];
            case 7: return [3 /*break*/, 10];
            case 8:
                e_1_1 = _c.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 10];
            case 9:
                try {
                    if (result_1_1 && !result_1_1.done && (_b = result_1.return)) _b.call(result_1);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 10:
                querySelectorResult = (0, generate_query_selector_1.generateQuerySelector)(queryObject, types, false);
                return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/types/query-selector-result.ts"), querySelectorResult)];
            case 11:
                _c.sent();
                return [2 /*return*/, {
                        querySelector: querySelector,
                    }];
        }
    });
}); };
exports.generateSelectors = generateSelectors;
