"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseGraphqlField = void 0;
var format_field_1 = require("./format/format-field");
var parse_underlying_type_1 = require("./underlying-type/parse-underlying-type");
var console_messages_1 = require("../../../../../cli/console/console.messages");
var parseGraphqlField = function (field, isFunction) {
    if (field.defaultValue) {
        return {
            output: (0, format_field_1.formatField)(field.name, field.defaultValue, isFunction, false),
            type: '',
            gqlParams: '',
            gqlArgs: '',
        };
    }
    if (!field.name) {
        (0, console_messages_1.displayWarning)("getField: missing 'name' for field ".concat(JSON.stringify(field, null, 2)));
        return { output: '', type: '', gqlParams: '', gqlArgs: '' };
    }
    if (field.type.kind === 'NON_NULL') {
        return (0, parse_underlying_type_1.parseUnderlyingType)(field.name, field.type.ofType, isFunction, false);
    }
    return (0, parse_underlying_type_1.parseUnderlyingType)(field.name, field.type, isFunction, true);
};
exports.parseGraphqlField = parseGraphqlField;
