"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseList = void 0;
var console_messages_1 = require("../../../../../../../cli/console/console.messages");
var translate_graphql_type_to_typescript_1 = require("../../../../../typescript/translate-graphql-type-to-typescript");
var format_field_1 = require("../../format/format-field");
var parseList = function (kind, name, type, isFunction, isNull) {
    var maybeNull = isNull ? '' : '!';
    if (kind === 'OBJECT' || kind === 'INPUT_OBJECT' || kind === 'ENUM') {
        return {
            output: (0, format_field_1.formatField)(name, "Array<".concat(type, ">"), isFunction, isNull),
            type: "Array<".concat(type, ">"),
            gqlParams: "$".concat(name, ": [").concat(type).concat(maybeNull, "]").concat(maybeNull),
            gqlArgs: "".concat(name, ": $").concat(name),
        };
    }
    else if (kind === 'SCALAR') {
        return {
            output: (0, format_field_1.formatField)(name, "Array<".concat((0, translate_graphql_type_to_typescript_1.translateGraphqlTypeToTypescript)(type), ">"), isFunction, isNull),
            type: "Array<".concat((0, translate_graphql_type_to_typescript_1.translateGraphqlTypeToTypescript)(type), ">"),
            gqlParams: "$".concat(name, ": [").concat(type).concat(maybeNull, "]").concat(maybeNull),
            gqlArgs: "".concat(name, ": $").concat(name),
        };
    }
    (0, console_messages_1.displayWarning)("List parsing: unhandled field 'name' for kind ".concat(kind, " and type ").concat(type));
    return { output: '', type: '', gqlArgs: '', gqlParams: '' };
};
exports.parseList = parseList;
