"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseGraphqlObject = void 0;
var parse_graphql_field_1 = require("./field-parsing/parse-graphql-field");
var parseGraphqlObject = function (name, fields) {
    if (!fields) {
        return {
            output: '',
            typesObject: {},
        };
    }
    var result = fields.reduce(function (out, field) {
        var res = (0, parse_graphql_field_1.parseGraphqlField)(field, false);
        out.output += res.output;
        out.typesObject[field.name] = res.type;
        return out;
    }, {
        output: '',
        typesObject: {},
    });
    return __assign(__assign({}, result), { output: "export interface ".concat(name, " { ").concat(result.output, "}\n") });
};
exports.parseGraphqlObject = parseGraphqlObject;
