import { GqlType } from '../../../types/introspection-query-response.type';
import { SchemaTypesRoot } from '../../../types/schema-types-root.type';
export type ParsedType = {
    name: string;
    type: 'arg' | 'enum' | 'type';
    data: string;
};
export type ParsedArg = {
    type: string;
    name: string;
    imports: Array<string>;
    gqlParams: Array<string>;
    gqlArgs: Array<string>;
    data: string;
};
export type ParseTypesResult = {
    count: number;
    types: Array<ParsedType>;
    args: Array<ParsedArg>;
    typesObject: SchemaTypesRoot;
};
export declare const translateGraphqlTypesToTypescript: (input: Array<GqlType>) => ParseTypesResult;
