"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.translateGraphqlTypesToTypescript = void 0;
var extract_args_types_1 = require("./args-types/extract-args-types");
var parse_graphql_object_1 = require("./object-parsing/parse-graphql-object");
var translateGraphqlTypesToTypescript = function (input) {
    var output = input.reduce(function (result, _a) {
        var _b;
        var kind = _a.kind, name = _a.name, fields = _a.fields, inputFields = _a.inputFields, enumValues = _a.enumValues;
        if (name.startsWith('__')) {
            return result;
        }
        var isRoutesObject = name === 'Query' || name === 'Mutation';
        if (isRoutesObject) {
            var args_1 = (0, extract_args_types_1.extractArgsTypes)(name, fields);
            (_b = result.args).push.apply(_b, __spreadArray([], __read(args_1), false));
        }
        if (kind === 'ENUM') {
            var typeOutput = "export type ".concat(name, " = ").concat(enumValues === null || enumValues === void 0 ? void 0 : enumValues.map(function (v) { return "'".concat(v.name, "'"); }).join(' | '));
            result.types.push({
                name: name,
                type: 'enum',
                data: typeOutput,
            });
            result.count++;
            return result;
        }
        var isObject = kind === 'OBJECT' || kind === 'INPUT_OBJECT';
        if (isObject) {
            var target = kind === 'OBJECT' ? fields : inputFields;
            var _c = (0, parse_graphql_object_1.parseGraphqlObject)(name, target), output_1 = _c.output, t = _c.typesObject;
            result.typesObject[name] = t;
            result.types.push({ name: name, data: output_1, type: 'type' });
            result.count += 1;
        }
        return result;
    }, {
        typesObject: {},
        types: [],
        args: [],
        count: 0,
    });
    var args = output.args.map(function (arg) { return (__assign(__assign({}, arg), { imports: arg.imports.filter(function (i) { return output.types.some(function (t) { return t.name === i; }); }) })); });
    return {
        types: output.types,
        args: args,
        typesObject: __assign({}, output.typesObject),
        count: output.count,
    };
};
exports.translateGraphqlTypesToTypescript = translateGraphqlTypesToTypescript;
