"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateQuerySelector = void 0;
var chalk_1 = __importDefault(require("chalk"));
var get_query_fields_1 = require("./query-fields/get-query-fields");
var console_messages_1 = require("../../../cli/console/console.messages");
var getFieldType = function (input) {
    var _a, _b, _c, _d;
    if (((_a = input.ofType) === null || _a === void 0 ? void 0 : _a.kind) === 'LIST') {
        return {
            type: (_c = (_b = input.ofType.ofType) === null || _b === void 0 ? void 0 : _b.ofType) === null || _c === void 0 ? void 0 : _c.name,
            maybeArray: '[]',
        };
    }
    else if (((_d = input.ofType) === null || _d === void 0 ? void 0 : _d.kind) === 'OBJECT') {
        return {
            type: input.ofType.name,
            maybeArray: '',
        };
    }
    return {
        type: '',
        maybeArray: '',
    };
};
var generateQuerySelector = function (queryObject, types, booleanize) {
    var _a, _b;
    if (booleanize === void 0) { booleanize = true; }
    var empty = {
        output: '',
        imports: [],
    };
    var _c = (_b = (_a = queryObject.fields) === null || _a === void 0 ? void 0 : _a.reduce(function (acc, _a) {
        var name = _a.name, fieldType = _a.type;
        var _b = getFieldType(fieldType), type = _b.type, maybeArray = _b.maybeArray;
        var _c = (0, get_query_fields_1.getQueryFields)(name, type, types, booleanize), queryOutput = _c.queryOutput, queryImports = _c.queryImports, circularDependencies = _c.circularDependencies;
        if (circularDependencies.length > 0) {
            (0, console_messages_1.displayWarning)("Circular references detected in ".concat(name, " query:\n").concat(chalk_1.default.gray(circularDependencies.join('\n')), "\n"));
        }
        return {
            output: "".concat(acc.output).concat(name).concat(booleanize ? '?' : '', ": ").concat(queryOutput).concat(booleanize ? '' : maybeArray, "\n"),
            imports: __spreadArray(__spreadArray([], __read(acc.imports), false), __read(queryImports), false),
        };
    }, empty)) !== null && _b !== void 0 ? _b : empty, output = _c.output, imports = _c.imports;
    var importsString = booleanize || imports.length === 0
        ? ''
        : "import {".concat(imports
            .filter(function (value, index, array) { return array.indexOf(value) === index; })
            .join(','), "} from './api-types'\n\n");
    return "".concat(importsString, "export type QuerySelector").concat(booleanize ? '' : 'Result', " = {\n").concat(output, "}");
};
exports.generateQuerySelector = generateQuerySelector;
