"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getQueryFields = void 0;
var logic_1 = require("./logic");
var emptyResult = {
    queryImports: [],
    queryOutput: '',
    circularDependencies: [],
};
var getQueryFields = function (queryName, name, types, booleanize, past) {
    if (past === void 0) { past = []; }
    var typeInfos = types.find(function (t) { return t.name === name; });
    if (!typeInfos) {
        return emptyResult;
    }
    var properties = (0, logic_1.getTypeProperties)(name, typeInfos.data);
    if (!properties) {
        return emptyResult;
    }
    var _a = properties.reduce(function (acc, property) {
        var circularDependencies = [];
        var _a = __read(property.split(':'), 2), propertyName = _a[0], type = _a[1];
        var maybeArrayAnnotation = (0, logic_1.getMaybeArrayAnnotation)(booleanize, type);
        var rawType = (0, logic_1.getRawType)(type);
        var hasCircularDependency = past.some(function (p) { return p.propertyName === propertyName && p.rawType === rawType; });
        if (hasCircularDependency) {
            return __assign(__assign({}, acc), { circularDependencies: [
                    "- property ".concat(propertyName, " in ").concat(name, " <-> ").concat(rawType),
                ] });
        }
        var propertyTypeInfos = types.find(function (t) { return t.name === rawType; });
        var isScalar = !propertyTypeInfos || propertyTypeInfos.type === 'enum';
        if (isScalar) {
            var isEnum = (propertyTypeInfos === null || propertyTypeInfos === void 0 ? void 0 : propertyTypeInfos.type) === 'enum';
            return {
                imports: isEnum ? __spreadArray(__spreadArray([], __read(acc.imports), false), [type], false) : acc.imports,
                output: (0, logic_1.formatScalar)(acc.output, property, booleanize, type, maybeArrayAnnotation),
                circularDependencies: __spreadArray(__spreadArray([], __read(acc.circularDependencies), false), __read(circularDependencies), false),
            };
        }
        past.push({ propertyName: propertyName, rawType: rawType });
        var deep = (0, exports.getQueryFields)(queryName, rawType, types, booleanize, past);
        var member = "".concat(propertyName).concat(booleanize ? (0, logic_1.setOptional)(propertyName.endsWith('?')) : '', ": ") +
            deep.queryOutput +
            maybeArrayAnnotation +
            ';';
        return {
            output: acc.output + member,
            imports: __spreadArray(__spreadArray([], __read(acc.imports), false), __read(deep.queryImports), false),
            circularDependencies: __spreadArray(__spreadArray([], __read(acc.circularDependencies), false), __read(deep.circularDependencies), false),
        };
    }, {
        imports: [],
        output: '',
        circularDependencies: [],
    }), imports = _a.imports, output = _a.output, circularDependencies = _a.circularDependencies;
    return {
        queryOutput: "{ ".concat(output, " }"),
        queryImports: imports,
        circularDependencies: circularDependencies,
    };
};
exports.getQueryFields = getQueryFields;
