"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEndpointsObjects = void 0;
var console_messages_1 = require("../../../cli/console/console.messages");
var getEndpointsObjects = function (schemaTypes) {
    var queryObject = schemaTypes.find(function (el) { return el.name === 'Query' && el.kind === 'OBJECT' && el.fields !== null; });
    if (!queryObject) {
        (0, console_messages_1.displayError)('Missing Query object in schema');
        process.exit(1);
    }
    var mutationObject = schemaTypes.find(function (el) {
        return el.name === 'Mutation' && el.kind === 'OBJECT' && el.fields !== null;
    });
    if (!mutationObject) {
        (0, console_messages_1.displayError)('Missing Mutation object in schema');
        process.exit(1);
    }
    return { queryObject: queryObject, mutationObject: mutationObject };
};
exports.getEndpointsObjects = getEndpointsObjects;
