"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateFromUrl = void 0;
var fs_extra_1 = require("fs-extra");
var generate_entry_point_1 = require("../logic/codegen/entry-point/generate-entry-point");
var generate_infinite_queries_1 = require("../logic/codegen/infinite-queries/generate-infinite-queries");
var generate_mutations_1 = require("../logic/codegen/mutations/generate-mutations");
var generate_queries_1 = require("../logic/codegen/queries/generate-queries");
var generate_query_replacer_1 = require("../logic/codegen/queries/query-replacer/generate-query-replacer");
var generate_selectors_1 = require("../logic/codegen/selectors/generate-selectors");
var write_static_code_1 = require("../logic/codegen/static-code/write-static-code");
var fetch_graphql_schema_1 = require("../logic/fetching/fetch-graphql-schema");
var get_types_with_enums_object_1 = require("../logic/parsing/graphql-types/enums-picking/get-types-with-enums-object");
var translate_graphql_types_to_typescript_1 = require("../logic/parsing/graphql-types/translate-graphql-types-to-typescript");
var get_endpoints_objects_1 = require("../logic/parsing/selectors/get-endpoints-objects");
var capitalize_1 = require("../logic/util/capitalize");
var generateFromUrl = function (_a) {
    var schemaUrl = _a.schemaUrl, outputPath = _a.outputPath, fetcher = _a.fetcher, infiniteQueries = _a.infiniteQueries;
    return __awaiter(void 0, void 0, void 0, function () {
        var schemaTypes, _b, queryObject, mutationObject, _c, count, types, typesObject, args, typesWithEnumsObject, args_1, args_1_1, _d, type, name_1, i, data, maybeImports, e_1_1, selectors, queryReplacer, generatedInfiniteQueries;
        var e_1, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0: return [4 /*yield*/, (0, fetch_graphql_schema_1.fetchGraphqlSchema)(schemaUrl)];
                case 1:
                    schemaTypes = _f.sent();
                    _b = (0, get_endpoints_objects_1.getEndpointsObjects)(schemaTypes), queryObject = _b.queryObject, mutationObject = _b.mutationObject;
                    _c = (0, translate_graphql_types_to_typescript_1.translateGraphqlTypesToTypescript)(schemaTypes), count = _c.count, types = _c.types, typesObject = _c.typesObject, args = _c.args;
                    typesWithEnumsObject = (0, get_types_with_enums_object_1.getTypesWithEnumsObject)(typesObject, types);
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/types"))];
                case 2:
                    _f.sent();
                    return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/types/api-types.ts"), types.map(function (el) { return el.data; }).join('\n'))];
                case 3:
                    _f.sent();
                    _f.label = 4;
                case 4:
                    _f.trys.push([4, 10, 11, 12]);
                    args_1 = __values(args), args_1_1 = args_1.next();
                    _f.label = 5;
                case 5:
                    if (!!args_1_1.done) return [3 /*break*/, 9];
                    _d = args_1_1.value, type = _d.type, name_1 = _d.name, i = _d.imports, data = _d.data;
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/types/").concat(type, "/").concat(name_1))];
                case 6:
                    _f.sent();
                    maybeImports = i.length > 0
                        ? "import {".concat(i.join(', '), "} from '../../api-types';\n\n")
                        : '';
                    return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/types/").concat(type, "/").concat(name_1, "/").concat((0, capitalize_1.capitalize)(name_1)).concat((0, capitalize_1.capitalize)(type === 'queries' ? 'Query' : 'Mutation'), "Args.type.ts"), "".concat(maybeImports).concat(data))];
                case 7:
                    _f.sent();
                    _f.label = 8;
                case 8:
                    args_1_1 = args_1.next();
                    return [3 /*break*/, 5];
                case 9: return [3 /*break*/, 12];
                case 10:
                    e_1_1 = _f.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 11:
                    try {
                        if (args_1_1 && !args_1_1.done && (_e = args_1.return)) _e.call(args_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 12: return [4 /*yield*/, (0, generate_selectors_1.generateSelectors)(queryObject, types, outputPath)];
                case 13:
                    selectors = _f.sent();
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/logic"))];
                case 14:
                    _f.sent();
                    return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/logic/types-with-enums-object.ts"), "export const typesWithEnumsObject = ".concat(JSON.stringify(typesWithEnumsObject, null, 2)))];
                case 15:
                    _f.sent();
                    queryReplacer = (0, generate_query_replacer_1.generateQueryReplacer)(queryObject);
                    return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/logic/query-replacer.ts"), queryReplacer)];
                case 16:
                    _f.sent();
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/queries"))];
                case 17:
                    _f.sent();
                    return [4 /*yield*/, (0, generate_queries_1.generateQueries)(queryObject.fields, fetcher, outputPath, selectors, args)];
                case 18:
                    _f.sent();
                    return [4 /*yield*/, (0, generate_infinite_queries_1.generareInfiniteQueries)(queryObject.fields, infiniteQueries, fetcher, outputPath, selectors)];
                case 19:
                    generatedInfiniteQueries = _f.sent();
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/mutations"))];
                case 20:
                    _f.sent();
                    return [4 /*yield*/, (0, generate_mutations_1.generateMutations)(mutationObject.fields, types, fetcher, outputPath)];
                case 21:
                    _f.sent();
                    return [4 /*yield*/, (0, write_static_code_1.writeStaticCode)(outputPath)];
                case 22:
                    _f.sent();
                    return [4 /*yield*/, (0, generate_entry_point_1.generateEntryPoint)(outputPath, queryObject, mutationObject, generatedInfiniteQueries)];
                case 23:
                    _f.sent();
                    return [2 /*return*/, { typesCount: count }];
            }
        });
    });
};
exports.generateFromUrl = generateFromUrl;
