export declare const queryHookContent = "import { useQuery, UseQueryResult, UseQueryOptions, QueryKey } from '@tanstack/react-query';\n\n#fetcher-hook-import#\nimport { namedQuerySelectorToDocument } from '../logic/named-query-selector-to-document';\nimport { DeepReplace } from '../types/deep-replace.type';\nimport { QuerySelector } from '../types/query-selector';\nimport { QuerySelectorResult } from '../types/query-selector-result';\n#args-type-import#\n#result-type-import#\ntype #type#SelectorResult = Pick<QuerySelectorResult, '#name#'>['#name#'];\n\n#args-type#\n\nexport type #type#QueryResultSelect<Selector> = {\n  #name#: DeepReplace<Selector, #type#SelectorResult>;\n};\n\nexport const use#type#PartialQuery = <Selector extends Pick<QuerySelector, '#name#'>['#name#']>(\n  selector: Selector, #variables-argument#\n  options?: Omit<\n  UseQueryOptions<\n    #type#QueryResultSelect<Selector>,\n    unknown,\n    #type#QueryResultSelect<Selector>\n  >,\n  'queryFn' | 'queryKey'\n>\n): UseQueryResult<#type#QueryResultSelect<Selector>> => {\n  const document = namedQuerySelectorToDocument('#name#', selector#params-args#);\n\n  return useQuery<#type#QueryResultSelect<Selector>, unknown, #type#QueryResultSelect<Selector>>({\n    queryKey: ['#name#'#query-key-variables#],\n    queryFn: #fetcherFn#<#type#QueryResultSelect<Selector>>(document)#variables-binding#,\n    ...options\n  });\n};\n\nexport type #type#QueryResultType = { #name#?: #outputType# };\n\nexport const use#type#Query = (\n  #variables-argument#\n  options?: Omit<\n    UseQueryOptions<\n      #type#QueryResultType,\n      unknown,\n      #type#QueryResultType\n    >,\n    'queryFn' | 'queryKey'\n  >\n): UseQueryResult<#type#QueryResultType> =>\n  use#type#PartialQuery(\n    {\n      #full-selector#\n    }#variables#\n    ,options as never\n  );\n\nuse#type#Query.getKey = #queryKey#\n";
