export declare const stringifyObjectContent = "/* eslint-disable @typescript-eslint/no-explicit-any */\nimport { typesWithEnumsObject } from './types-with-enums-object';\nimport { isObject } from './is-object';\n\nconst repeatTabs = (count: number): string =>\n  count === 0 ? '' : '  '.repeat(count - 1);\n\nconst stringifyObject = (input: any, typeName: string, level = 2): string => {\n  const tabs = repeatTabs(level);\n\n  const r = Object.entries(input).reduce((acc, [key, value], index, o) => {\n    const trailing = index < o.length - 1 ? '\\n' : '';\n\n    const t = (typesWithEnumsObject as Record<string, Record<string, string>>)[\n      typeName\n    ];\n    if (t && key in t) {\n      acc += `${tabs}${key}: ${value}${trailing}`;\n    } else if (typeof value === 'string') {\n      acc += `${tabs}${key}: \"${value}\"${trailing}`;\n    } else if (value !== undefined) {\n      acc += `${tabs}${key}: ${value}${trailing}`;\n    }\n\n    return acc;\n  }, '');\n\n  return `{\n${r}\n}`;\n};\n\nexport const stringify = (input: any, typeName: string, level = 2): string => {\n  if (Array.isArray(input)) {\n    return `[${input.map((el) =>\n      isObject(el) ? stringifyObject(el, typeName) : el\n    )}]`;\n  } else if (isObject(input)) {\n    return stringifyObject(input, typeName, level);\n  } \n\n  return input;\n};\n";
